import os
import os.path
import random
import math
import errno

from data import common

import numpy as np
import scipy.misc as misc

import torch
import torch.utils.data as data
from torchvision import transforms

class MyImage(data.Dataset):
    def __init__(self, args, train=False):
        self.args = args
        self.train = False
        self.name = 'MyImage'
        self.scale = args.scale
        self.idx_scale = 0
        apath = args.testpath + '/' + args.testset + '/x' + str(args.scale[0])
        apath1 = args.testpath1 + '/' + args.testset + '/x' + str(args.scale[0])
        self.filelist = []
        self.imnamelist = []
        self.filelist1= []
        self.imnamelist1 = []
        if not train:
            for f, f1 in zip(os.listdir(apath),os.listdir(apath1)):
                try:
                    filename = os.path.join(apath, f)
                    filename1 = os.path.join(apath1, f1)
                    misc.imread(filename)
                    misc.imread(filename1)
                    self.filelist.append(filename)
                    self.imnamelist.append(f)
                    self.filelist1.append(filename1)
                    self.imnamelist1.append(f1)
                except:
                    pass

    def __getitem__(self, idx):
        filename = os.path.split(self.filelist[idx])[-1]
        filename, _ = os.path.splitext(filename)
        lr = misc.imread(self.filelist[idx])
        hr = misc.imread(self.filelist1[idx])
        # hr = self.images_hr[idx]
        # hr = lr
        lr = common.set_channel([lr], self.args.n_colors)[0]
        lr = common.add_noise(lr, self.args.noise, 10)
        return common.np2Tensor([lr], self.args.rgb_range)[0], common.np2Tensor([hr], self.args.rgb_range)[0], filename
    def __len__(self):
        return len(self.filelist)

    def set_scale(self, idx_scale):
        self.idx_scale = idx_scale

