import torch

import utility
import data
import model
import loss
from option import args
from trainer import Trainer


if __name__=='__main__':
    args.dir_data='C:/Users/fubo/Desktop/UWater/RCAN_TrainCode/DIV2K'
    args.scale =[1]
    args.model='RCAN'
    args.n_resgroups = 2
    args.n_resblocks = 2
    args.n_feats = 64
    args.reset=True
    args.save_results = True
    args.chop = True
    args.save='Result'
    args.print_model=True
    args.ext = 'sep'#sep_reset
    torch.manual_seed(args.seed)
    import datetime
    start = datetime.datetime.now()

    checkpoint = utility.checkpoint(args)

    if checkpoint.ok:
        loader = data.Data(args)
        model = model.Model(args, checkpoint)
        loss = loss.Loss(args, checkpoint) if not args.test_only else None
        t = Trainer(args, loader, model, loss, checkpoint)
        while not t.terminate():
                t.train()
                t.test()

        checkpoint.done()


    end = datetime.datetime.now()
    print('totally time is ', end - start)


